/* Handy dandy debug-a-loo */
#ifndef __DEBUG_H__

#define __DEBUG_H__

#ifdef DEBUG_A_LOO

#define dmsg( x, y, args... )	if( x <= _DEBUGLEVEL ) { fprintf( stderr, y, ## args ); fprintf( stderr, "\n" ); }
#define debug_level( x )	_DEBUGLEVEL = x
extern int _DEBUGLEVEL;

#else

#define dmsg( x, y... )		/* */
#define debug_level( x )	fprintf( stderr, "Debugging not enabled, could not set debug level\n" )

#endif /* DEBUG_A_LOO */

#endif /* __DEBUG_H__ */
